import 'package:bit_ads_pakage_all/ads/banner_ads.dart';
import 'package:bit_ads_pakage_all/ads/interstitial_ads.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'ads/model/admob_settings.dart';

class AdsManager {

  static late AdmobSettings _admobSettings;
  static late bool _isTestAds = false;

 static init({required Map<String,dynamic> admobSettingsJson,bool isTestAds = false})
  {
    _admobSettings = AdmobSettings.fromJson(admobSettingsJson);
    _isTestAds = isTestAds;
    InterstitialAds.init(_admobSettings, _isTestAds);
  }

  static Widget showBannerAds()
  {
    return BannerAds(admobSettings: _admobSettings, isTestAds:_isTestAds);
  }

  static Future<void> showInterstitialAds(BuildContext context)
  async {
    if (context != null) {
      await InterstitialAds.showInterstitialAds(context);
    }
    else
      {
        await InterstitialAds.showInterstitialAds(Get.context);
      }
  }

}
