import 'dart:math';
import 'package:flutter/material.dart';
import 'package:flutter_google_ad_manager/ad_size.dart';
import 'package:flutter_google_ad_manager/banner.dart';
import 'package:unity_ads_plugin/unity_ads_plugin.dart';
import 'package:url_launcher/url_launcher.dart';
import 'package:webview_flutter_x5/webview_flutter.dart';
import 'model/admob_settings.dart';

class BannerAds extends StatefulWidget {
  final AdmobSettings? admobSettings;
  final bool isTestAds;

  const BannerAds({Key? key, this.admobSettings, required this.isTestAds}) : super(key: key);

  @override
  _BannerAdsState createState() => _BannerAdsState();
}

class _BannerAdsState extends State<BannerAds> {
  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    bannerAdsLogic();
  }

  dynamic bannerAds;
  bool bannerAdGoogle = false;
  bool bannerAdUnity = false;
  bool bannerAdWebView = false;

  bannerAdsLogic() {
    bannerAdGoogle = false;
    bannerAdUnity = false;
    bannerAdWebView = false;


    int googleAdsRange = widget.admobSettings!.googleAds!.visibilityPercentage!;
    int unityAdsPakageRange =
        googleAdsRange + widget.admobSettings!.unityAds!.visibilityPercentage!;
    int customAdsRange = unityAdsPakageRange +
        widget.admobSettings!.customAds!.visibilityPercentage!; // total range

    var rng = Random();
    int randomNumber = rng.nextInt(customAdsRange);
    //
    if (widget.admobSettings!.isBannerAds == true) {
      if (randomNumber <= googleAdsRange) {
        if (widget.admobSettings!.googleAds!.isBannerAds == true) {
          setState(() {
            bannerAdGoogle = true;
          });
        } else if (widget.admobSettings!.unityAds!.isBannerAds == true) {
          setState(() {
            bannerAdUnity = true;
          });
        } else if (widget.admobSettings!.customAds!.isBannerAds == true) {
          setState(() {
            bannerAdWebView = true;
          });
        }
      } else if (randomNumber > googleAdsRange &&
          randomNumber <= unityAdsPakageRange) {
        if (widget.admobSettings!.unityAds!.isBannerAds == true) {
          setState(() {
            bannerAdUnity = true;
          });
        } else if (widget.admobSettings!.googleAds!.isBannerAds == true) {
          setState(() {
            bannerAdGoogle = true;
          });
        } else if (widget.admobSettings!.customAds!.isBannerAds == true) {
          setState(() {
            bannerAdWebView = true;
          });
        }
      } else if (randomNumber > unityAdsPakageRange &&
          randomNumber <= customAdsRange) {
        if (widget.admobSettings!.customAds!.isBannerAds == true) {
          setState(() {
            bannerAdWebView = true;
          });
        } else if (widget.admobSettings!.googleAds!.isBannerAds == true) {
          setState(() {
            bannerAdGoogle = true;
          });
        }
        else
        {
          if (widget.admobSettings!.unityAds!.isBannerAds == true) {
            setState(() {
              bannerAdUnity = true;
            });
          }
        }
      }
    }

    if (bannerAdGoogle == true) {
      setState(
        () {
          bannerAds = DFPBanner(
              isDevelop: widget.isTestAds,
              adUnitId:
                  '${widget.admobSettings!.googleAds!.bannerAdUnitIdAndroid}',
              adSize: DFPAdSize.BANNER,
              onAdFailedToLoad: (errorCode) {
                setState(() {
                  if (widget.admobSettings!.unityAds!.isBannerAds == true && widget.admobSettings!.unityAds!.visibilityPercentage! > 0) {
                    bannerAds = UnityBannerAd(
                        placementId: 'Banner_Android',
                        onFailed: (placementId, error, message) {
                          setState(() {
                            bannerAds = Container(
                              height: 55,
                              child: WebView(
                                navigationDelegate: (action) {
                                  return _launchURL(action.url);
                                  // return NavigationDecision.navigate;
                                },
                                javascriptMode: JavascriptMode.unrestricted,
                                initialUrl:
                                '${widget.admobSettings!.customAds!
                                    .bannerAdsUrl}',
                              ),
                            );
                          });
                        });
                  }
                  else
                    {
                       bannerAds = Container(
                          height: 55,
                          child: WebView(
                            navigationDelegate: (action) {
                              return _launchURL(action.url);
                              // return NavigationDecision.navigate;
                            },
                            javascriptMode: JavascriptMode.unrestricted,
                            initialUrl:
                            '${widget.admobSettings!.customAds!
                                .bannerAdsUrl}',
                          ),
                        );
                    }
                });
              });
        },
      );
    } else if (bannerAdUnity == true) {
      setState(() {
        bannerAds = UnityBannerAd(
            placementId: 'Banner_Android',
            onFailed: (placementId, error, message) {
             setState(() {
               if (widget.admobSettings!.googleAds!.isBannerAds == true && widget.admobSettings!.googleAds!.visibilityPercentage! > 0) {
                 bannerAds = DFPBanner(
                   isDevelop: false,
                   adUnitId:
                   '${widget.admobSettings!.googleAds!.bannerAdUnitIdAndroid}',
                   adSize: DFPAdSize.BANNER,
                   onAdLoaded: () {
                     print('Banner onAdLoaded');
                   },
                   onAdFailedToLoad: (errorCode) {
                     setState(() {
                       bannerAds = Container(
                         height: 55,
                         child: WebView(
                           navigationDelegate: (action) {
                             return _launchURL(action.url);
                             // return NavigationDecision.navigate;
                           },
                           javascriptMode: JavascriptMode.unrestricted,
                           initialUrl:
                           '${widget.admobSettings!.customAds!.bannerAdsUrl}',
                         ),
                       );
                     });
                   },
                 );
               }
               else
                 {
                   bannerAds = Container(
                     height: 55,
                     child: WebView(
                       navigationDelegate: (action) {
                         return _launchURL(action.url);
                         // return NavigationDecision.navigate;
                       },
                       javascriptMode: JavascriptMode.unrestricted,
                       initialUrl:
                       '${widget.admobSettings!.customAds!.bannerAdsUrl}',
                     ),
                   );
                 }
             });
            });
      });
    } else if (bannerAdWebView == true) {
      setState(() {
        bannerAds = Container(
          height: 55,
          child: WebView(
            navigationDelegate: (action) {
              return _launchURL(action.url);
              // return NavigationDecision.navigate;
            },
            javascriptMode: JavascriptMode.unrestricted,
            initialUrl: '${widget.admobSettings!.customAds!.bannerAdsUrl}',
          ),
        );
      });
    } else {
      setState(() {
        bannerAds = Container();
      });
    }
  }

  _launchURL(String url) async {
    if (await canLaunch(url)) {
      await launch(url);
    } else {
      throw 'Could not launch $url';
    }
  }

  @override
  Widget build(BuildContext context) {
    if (widget.admobSettings!.googleAds!.isBannerAds == true ||
        (widget.admobSettings!.googleAds!.visibilityPercentage! > 0 &&
            widget.admobSettings!.googleAds!.isBannerAds == true) ||
        (widget.admobSettings!.unityAds!.visibilityPercentage! > 0 &&
            widget.admobSettings!.unityAds!.isBannerAds == true) ||
        (widget.admobSettings!.customAds!.visibilityPercentage! > 0 &&
            widget.admobSettings!.customAds!.isBannerAds == true)) {
      return Container(
          color: Colors.black,
          width: double.infinity,
          height: 55,
          child: Stack(
            children: [
              Center(
                child: Text(
                  "${widget.admobSettings!.adsLoadingText}",
                  style: TextStyle(fontSize: 25, color: Colors.white),
                ),
              ),
              Center(
                child: bannerAds,
              )
            ],
          ));
    } else {
      return Container(
        height: 0,
      );
    }
  }
}
