import 'dart:math';
import 'package:bit_ads_pakage_all/ad_manager.dart';
import 'package:flutter/material.dart';
import 'package:flutter_google_ad_manager/interstitial_ad.dart';
import 'package:get/get.dart';
import 'package:simple_fontellico_progress_dialog/simple_fontico_loading.dart';
import 'package:unity_ads_plugin/unity_ads_plugin.dart';
import '../webview.dart';
import 'model/admob_settings.dart';

class InterstitialAds {
  static SimpleFontelicoProgressDialog? _dialog;

  static _showDialog(BuildContext context,
      SimpleFontelicoProgressDialogType type, String text) async {
    if (_dialog == null) {
      _dialog = SimpleFontelicoProgressDialog(
          context: context, barrierDimisable: false);
    }

    _dialog?.show(
        message: "${_admobSettings!.adsLoadingText}",
        type: type,
        backgroundColor: Colors.yellow,
        width: 150.0,
        height: 105.0,
        radius: 10,
        indicatorColor: Colors.black,
        loadingIndicator: Text(
          '${_admobSettings!.adsLoadingText}',
          style: TextStyle(fontSize: 40),
        ));
  }

  static AdmobSettings? _admobSettings;
  static bool? _isTestAds;

  static void init(AdmobSettings admobSettings, bool isTestAds) {
    _admobSettings = admobSettings;
    _isTestAds = isTestAds;
    _loadInterstitial();
  }

  // String customAdsList = SettingsApiController.to.settingsModel.settings.admobSettings.googleAds.interstitialAdUnitIdAndroid;

  static DFPInterstitialAd? _interstitialAd;
  static RxBool webviewAds = false.obs;

  static _loadInterstitial() {

    UnityAds.init(
      gameId: "${_admobSettings!.unityAds!.adsAppIdAndroid}",
      testMode: _isTestAds!,
    );

    _interstitialAd = DFPInterstitialAd(
      isDevelop: _isTestAds,
      adUnitId: "${_admobSettings!.googleAds!.interstitialAdUnitIdAndroid}",
      onAdFailedToLoad: (errorCode) {
        if (_admobSettings!.unityAds!.isInterstitialAds == true && _admobSettings!.unityAds!.visibilityPercentage! > 0) {
          UnityAds.showVideoAd(
              placementId: 'Video_Android',
              onFailed: (placementId, error, message) {
                Get.to(InterstitialWebView(admobSettings: _admobSettings,),preventDuplicates: false);
              });
        }
        else
          {
            Get.to(InterstitialWebView(admobSettings: _admobSettings),preventDuplicates: false);
          }
      },
      onAdClosed: () {
        print('interstitialAd onAdClosed');
        _interstitialAd!.load();
      },
    );
    _interstitialAd!.load();
  }

  static Future showInterstitialAds(context) async {
    int timerLoader = _admobSettings!.adsLoadingDelay!;

    int? googleAdsRange = _admobSettings!.googleAds!.visibilityPercentage;
    int? unityAdsPakageRange =
        googleAdsRange! + _admobSettings!.unityAds!.visibilityPercentage!;
    int? customAdsRange = unityAdsPakageRange +
        _admobSettings!.customAds!.visibilityPercentage!; // total range

    var rng = Random();
    int randomNumber = rng.nextInt(customAdsRange);

    if (_admobSettings!.isInterstitialAds == true) {
      if (randomNumber < googleAdsRange) {
        print("google");
        //TODO GOOGLE ADS

        if (_admobSettings!.googleAds!.isInterstitialAds == true) {
          // callback(context);
          _showDialog(context, SimpleFontelicoProgressDialogType.hurricane,
              'Hurricane');
          Future.delayed(Duration(milliseconds: timerLoader), () async {
            _interstitialAd!.show();
          }).then((value) {
            Get.back();
          });
        } else if (_admobSettings!.unityAds!.isInterstitialAds == true) {
          // callback(context);
          _showDialog(context, SimpleFontelicoProgressDialogType.hurricane,
              'Hurricane');
          Future.delayed(Duration(milliseconds: timerLoader), () {
            UnityAds.showVideoAd(
                    placementId: 'Video_Android',
                    onFailed: (placementId, error, message) {
                      Get.to(InterstitialWebView(admobSettings: _admobSettings,),preventDuplicates: false);
                    })
                .then((value) => Get.back());
          });
        } else if (_admobSettings!.customAds!.isInterstitialAds == true) {
          _showDialog(context, SimpleFontelicoProgressDialogType.hurricane,
              'Hurricane');
          // callback(context);
          Future.delayed(Duration(milliseconds: timerLoader), () {
            Get.back();
          }).then((value) => Get.to(InterstitialWebView(admobSettings: _admobSettings,),preventDuplicates: false));
        }

        //
      } else if (randomNumber > googleAdsRange &&
          randomNumber <= unityAdsPakageRange) {
        if (_admobSettings!.unityAds!.isInterstitialAds == true) {
          _showDialog(context, SimpleFontelicoProgressDialogType.hurricane,
              'Hurricane');
          // callback(context);
          Future.delayed(Duration(milliseconds: timerLoader), () {
            UnityAds.showVideoAd(
                    placementId: 'Video_Android',
                    onFailed: (placementId, error, message) {
                      Get.to(InterstitialWebView(admobSettings: _admobSettings,),preventDuplicates: false);
                    })
                .then((value) => Get.back());
          });
        } else if (_admobSettings!.googleAds!.isInterstitialAds == true) {
          _showDialog(context, SimpleFontelicoProgressDialogType.hurricane,
              'Hurricane');
          // callback(context);
          Future.delayed(Duration(milliseconds: timerLoader), () async {
            _interstitialAd!.show();
          }).then((value) {
            Get.back();
          });
        } else if (_admobSettings!.customAds!.isInterstitialAds == true) {
          _showDialog(context, SimpleFontelicoProgressDialogType.hurricane,
              'Hurricane');
          // callback(context);
          Future.delayed(Duration(milliseconds: timerLoader), () {
            Get.back();
          }).then((value) => Get.to(InterstitialWebView(admobSettings: _admobSettings,),preventDuplicates: false));
        }
        //
      } else if (randomNumber > unityAdsPakageRange &&
          randomNumber <= customAdsRange) {
        if (_admobSettings!.customAds!.isInterstitialAds == true) {
          _showDialog(context, SimpleFontelicoProgressDialogType.hurricane,
              'Hurricane');

          Future.delayed(Duration(milliseconds: timerLoader), () {
            Get.back();
          }).then((value) => Get.to(InterstitialWebView(admobSettings: _admobSettings,),preventDuplicates: false));
        } else if (_admobSettings!.googleAds!.isInterstitialAds == true) {
          _showDialog(context, SimpleFontelicoProgressDialogType.hurricane,
              'Hurricane');
          Future.delayed(Duration(milliseconds: timerLoader), () async {
            _interstitialAd!.show();
          }).then((value) {
            Get.back();
          });
        } else if (_admobSettings!.unityAds!.isInterstitialAds == true) {
          _showDialog(context, SimpleFontelicoProgressDialogType.hurricane,
              'Hurricane');
          Future.delayed(Duration(milliseconds: timerLoader), () {
            UnityAds.showVideoAd(
                    placementId: 'Video_Android',
                    onFailed: (placementId, error, message) {

                      Get.to(InterstitialWebView(admobSettings: _admobSettings,),preventDuplicates: false);
                    })
                .then((value) => Get.back());
          });
        }
      }
    }
  }
}

// callback(BuildContext context) {
//   showDialog(
//       barrierDismissible: false,
//       context: context,
//       builder: (BuildContext context) {
//         return Dialog(
//           shape: RoundedRectangleBorder(
//               borderRadius: BorderRadius.circular(20.0)), //this right here
//           child: Container(
//             color: Colors.black,
//             width: 50,
//             height: 90,
//             child: Row(
//               mainAxisAlignment: MainAxisAlignment.center,
//               crossAxisAlignment: CrossAxisAlignment.start,
//               children: [
//                 Center(
//                   child: CircularProgressIndicator(),
//                 ),
//                 SizedBox(
//                   width: 20,
//                 ),
//                 Center(
//                     child: Text(
//                   "${SettingsApiController.to.settingsModel.settings.admobSettings.adsLoadingText}",
//                   style: TextStyle(color: Colors.white),
//                 ))
//               ],
//             ),
//           ),
//         );
//       });
// }

// import 'dart:math';
// import 'dart:ui';
//
// import 'package:flutter/material.dart';
// import 'package:get/get.dart';
// import 'package:rating_bar/rating_bar.dart';
// import 'package:flutter_screenutil/flutter_screenutil.dart';
// import 'package:settings_utility/controllers/settings_api_controller.dart';
// import 'package:settings_utility/models/settings_model.dart';
// import 'package:settings_utility/utilities/method_utility.dart';
//
// class CustomInterstitialAds extends StatefulWidget {
//   @override
//   _CustomInterstitialAdsState createState() => _CustomInterstitialAdsState();
// }
//
// class _CustomInterstitialAdsState extends State<CustomInterstitialAds> {
//
//   AdsList customAds;
//   @override
//   void initState() {
//     // TODO: implement initState
//     super.initState();
//
//     List<AdsList> customAdsList = SettingsApiController.to.settingsModel.settings.admobSettings.customAds.adsList;
//     final _random = new Random();
//     customAds = customAdsList[_random.nextInt(customAdsList.length)];
//     // customAds = SettingsApiController.to.settingsModel.settings.admobSettings.customAds.adsList[0];
//   }
//
//   @override
//   Widget build(BuildContext context) {
//     return BackdropFilter(
//       filter:  ImageFilter.blur(sigmaX: 50, sigmaY: 50),
//       child: Scaffold(
//         backgroundColor: Colors.black.withOpacity(0.5),
//         body: SafeArea(
//           child: Stack(
//             children: [
//               LayoutBuilder(
//                 builder: (context, constraint) {
//                   return ConstrainedBox(
//                     constraints: BoxConstraints(minHeight: constraint.maxHeight),
//                     child: IntrinsicHeight(
//                       child: Container(
//                         child: Column(
//                           children: [
//                             Container(
//                               color: Color(customAds.bannerBgColor),
//                               width: double.infinity,
//                               child: Image.network(
//                                 customAds.bannerImage,
//                                 fit: BoxFit.contain,
//                               ),
//                             ),
//                             SizedBox(height: 20.h,),
//                             Container(
//                               width: 90.sp,
//                               height: 90.sp,
//                               child: Image.network(
//                                 customAds.logoImage,
//                                 fit: BoxFit.contain,
//                               ),
//                             ),
//                             SizedBox(height: 10.h,),
//                             Container(
//                               margin: EdgeInsets.only(bottom: 20.h),
//                               child: Column(
//                                 children: <Widget>[
//                                   Container(child: Text(customAds.title,
//                                     style: TextStyle(fontSize: 20.sp,
//                                       fontWeight: FontWeight.bold,
//                                       color: Colors.white,),
//                                     textAlign: TextAlign.center,),),
//                                   Container(
//                                     margin: EdgeInsets.symmetric(
//                                         vertical: 10.h),
//                                     child: Row(
//                                       mainAxisAlignment: MainAxisAlignment
//                                           .center,
//                                       children: <Widget>[
//                                         RatingBar.readOnly(
//                                           initialRating: customAds.ratings,
//                                           isHalfAllowed: true,
//                                           halfFilledIcon: Icons.star_half,
//                                           filledIcon: Icons.star,
//                                           emptyIcon: Icons.star_border,
//                                           filledColor: Colors.orangeAccent,
//                                         ),
//
//                                         Container(
//                                           margin: EdgeInsets.only(
//                                               left: 10.w),
//                                           child: Text("(${customAds.ratingsCount})",style: TextStyle(color: Colors.white),),
//                                         )
//                                       ],
//                                     ),
//                                   ),
//                                 ],
//                               ),
//                             ),
//                             Container(
//                               margin: EdgeInsets.only(bottom: 5.h),
//                               child: Text(customAds.subTitle,
//                                 style: TextStyle(
//                                     fontSize: 17.sp, color: Colors.white),
//                                 textAlign: TextAlign.center,),),
//                             Expanded(
//                               child: Container(
//                                 child: SingleChildScrollView(
//                                   child: Container(
//                                     margin: EdgeInsets.symmetric(
//                                         horizontal: 15.w, vertical: 5.h),
//                                     child: Text(customAds.description*100
//                                       , textAlign: TextAlign.center,
//                                       style: TextStyle(fontSize: 14.sp,
//                                           color: Colors.white.withOpacity(0.5)),),),
//                                 ),
//                               ),
//                             ),
//                             Container(
//                               height: 90.h,
//                               color: Color(customAds.footerBgColor).withOpacity(0.5),
//                             )
//                           ],
//                         ),
//                       ),
//                     ),
//                   );
//                 },
//               ),
//               Positioned(
//                   left: 0,
//                   top: 0,
//                   child:  InkWell(
//                     onTap: () {
//                       launchURL(customAds.privacyUrl);
//                     },
//                     child: Container(
//                       width: 17.sp,
//                       height: 17.sp,
//                       padding: EdgeInsets.all(2.sp),
//                       color: Colors.black54,
//                       alignment: Alignment.center,
//                       child: Row(
//                         mainAxisSize: MainAxisSize.min,
//                         children: <Widget>[
//                           Icon(
//                             Icons.info_outline, color: Colors.cyanAccent, size: 13.sp,),
//                         ],
//                       ),
//                     ),
//                   )),
//               Positioned(
//                   right: 0,
//                   top: 0,
//                   child:  InkWell(
//                     onTap: () {
//                      Get.back();
//                     },
//                     child: Container(
//                       width: 25.sp,
//                       height: 25.sp,
//                       padding: EdgeInsets.all(2.sp),
//                       color: Colors.red,
//                       alignment: Alignment.center,
//                       child: Row(
//                         mainAxisSize: MainAxisSize.min,
//                         children: <Widget>[
//                           Icon(
//                             Icons.close, color: Colors.white, size: 20.sp,),
//                         ],
//                       ),
//                     ),
//                   )
//               ),
//             ],
//           ),
//         ),
//         floatingActionButtonLocation: FloatingActionButtonLocation.centerFloat,
//         floatingActionButton:  FloatingActionButton(
//             elevation: 2,
//
//             backgroundColor: Color(customAds.goButtonBgColor),
//             onPressed: () {
//               launchURL(customAds.redirectUrl);
//               Navigator.pop(context);
//             },
//             child: Icon(Icons.keyboard_arrow_right, size: 40.sp,)
//         ),
//       ),
//     );
//   }
// }
//
//
// /*
// import 'dart:ui';
//
// import 'package:flutter/material.dart';
// import 'package:flutter_rating_bar/flutter_rating_bar.dart';
// import 'package:provider/provider.dart';
// import 'package:tiktalk/models/settings_model.dart';
// import 'package:tiktalk/notifiers/custom_ads_notifier.dart';
// import 'package:tiktalk/notifiers/settings_notifier.dart';
// import 'package:url_launcher/url_launcher.dart';
//
// class CustomInterstitialAds extends StatefulWidget {
//
//   @override
//   _CustomInterstitialAdsState createState() => _CustomInterstitialAdsState();
// }
//
// class _CustomInterstitialAdsState extends State<CustomInterstitialAds> {
//
//   GlobalKey _keyBanner = GlobalKey();
//   GlobalKey _keyLogo = GlobalKey();
//   GlobalKey _keyFooter = GlobalKey();
//   GlobalKey _keyBtnGo = GlobalKey();
//
//   double _sigma;
//
//   Size getBannerSize(GlobalKey _keyWidget) {
//     RenderBox renderBox = _keyWidget.currentContext.findRenderObject();
//     return renderBox.size;
//   }
//
//   _launchURL(String url) async {
//     if (await canLaunch(url)) {
//       await launch(url);
//     } else {
//       throw 'Could not launch $url';
//     }
//   }
//
//   @override
//   void initState() {
//     super.initState();
//     WidgetsBinding.instance.addPostFrameCallback(updateSize);
//   }
//
//   void updateSize(_) {
//     if(customAdsNotifier != null) {
//       customAdsNotifier.bannerSize = getBannerSize(_keyBanner);
//       customAdsNotifier.logoSize = getBannerSize(_keyLogo);
//       customAdsNotifier.footerSize = getBannerSize(_keyFooter);
//       customAdsNotifier.btnGoSize = getBannerSize(_keyBtnGo);
//     }
//   }
//
//   @override
//   Widget build(BuildContext context) {
//
//     customAdsNotifier = Provider.of<CustomAdsNotifier>(context,listen: false);
//     settingsNotifier = Provider.of<SettingsNotifier>(context,listen: false);
//
//     */
// /*List<AdsList> customAdsList = settingsNotifier.settingsModel.settings.admobSettings.customAds.adsList;
//     AdsList customAds = customAdsList[0];*//*
//
//
//     return BackdropFilter(
//         filter: new ImageFilter.blur(sigmaX: 100, sigmaY: 100),
//         child: Consumer<CustomAdsNotifier>(
//           builder: (context,data_custom_ads,_){
//
//             return Scaffold(
//                 backgroundColor: Colors.white.withOpacity(0.5),
//                 body: SafeArea(
//
//                   child: Stack(
//                     children: <Widget>[
//                       Consumer<SettingsNotifier>(
//                         builder: (context,data_setting,_) {
//                           List<AdsList> customAdsList = data_setting.settingsModel
//                               .settings.admobSettings.customAds.adsList;
//                           AdsList customAds = customAdsList[0];
//                           return Column(
//                             children: <Widget>[
//                               Expanded(
//                                 key: _keyBanner,
//                                 flex: 3,
//                                 child: InkWell(
//                                   onTap: (){
//                                     _launchURL(customAds.redirectUrl);
//                                   },
//                                   child: Container(
//                                     color: Colors.black,
//                                     width: double.infinity,
//                                     child: Image.network(
//                                       customAds.bannerImage,
//                                       fit: BoxFit.contain,
//
//                                     ),
//                                   ),
//                                 )
//                               ),
//                               Expanded(
//                                 flex: 7,
//                                 child: Consumer<SettingsNotifier>(
//                                     builder: (context, data_setting, _) {
//                                       List<AdsList> customAdsList = data_setting.settingsModel
//                                           .settings.admobSettings.customAds.adsList;
//                                       AdsList customAds = customAdsList[0];
//                                       return Container(
//                                         padding: EdgeInsets.only(top: 110 / 1.5),
//                                         color: Colors.white,
//                                         child: Column(
//                                           mainAxisAlignment: MainAxisAlignment.center,
//                                           children: <Widget>[
//                                             Container(
//                                               margin: EdgeInsets.only(bottom: 30),
//                                               child: Column(
//                                                 children: <Widget>[
//                                                   Container(child: Text(customAds.title,
//                                                     style: TextStyle(fontSize: 25,
//                                                       fontWeight: FontWeight.bold,
//                                                       color: Colors.black,),
//                                                     textAlign: TextAlign.center,),),
//                                                   Container(
//                                                     margin: EdgeInsets.symmetric(
//                                                         vertical: 10),
//                                                     child: Row(
//                                                       mainAxisAlignment: MainAxisAlignment
//                                                           .center,
//                                                       children: <Widget>[
//                                                         RatingBar(
//                                                           initialRating: 3.4,
//                                                           direction: Axis.horizontal,
//                                                           allowHalfRating: true,
//                                                           itemCount: 5,
//                                                           itemPadding: EdgeInsets
//                                                               .symmetric(
//                                                               horizontal: 4.0),
//                                                           itemBuilder: (context, _) {
//                                                             return Icon(
//                                                               Icons.star,
//                                                               color: Colors.amber,
//                                                             );
//                                                           },
//                                                           itemSize: 25,
//                                                           onRatingUpdate: (rating) {
//                                                             print(rating);
//                                                           },
//                                                         ),
//                                                         Container(
//                                                           margin: EdgeInsets.only(
//                                                               left: 10),
//                                                           child: Text("(12,45,00)"),
//                                                         )
//                                                       ],
//                                                     ),
//                                                   ),
//                                                 ],
//                                               ),
//                                             ),
//                                             Container(
//                                               margin: EdgeInsets.only(bottom: 5),
//                                               child: Text(customAds.title,
//                                                 style: TextStyle(
//                                                     fontSize: 18, color: Colors.black),
//                                                 textAlign: TextAlign.center,),),
//                                             Expanded(
//                                               child: Container(
//                                                 margin: EdgeInsets.only(
//                                                     bottom: (data_custom_ads.btnGoSize != null)
//                                                         ? data_custom_ads.btnGoSize.height / 1.5
//                                                         : 0),
//                                                 child: SingleChildScrollView(
//                                                   child: Container(
//                                                     margin: EdgeInsets.symmetric(
//                                                         horizontal: 15, vertical: 5),
//                                                     child: Text(customAds.description
//                                                       , textAlign: TextAlign.center,
//                                                       style: TextStyle(fontSize: 16,
//                                                           color: Colors.black54),),),
//                                                 ),
//                                               ),
//                                             ),
//
//                                           ],
//                                         ),
//
//                                       );
//                                     }
//                                 ),
//                               ),
//                               Expanded(
//                                 flex: 1,
//                                 key: _keyFooter,
//                                 child: Container(
//                                   color: Color(customAds.footerBgColor),
//                                 ),
//                               )
//                             ],
//                           );
//                         }
//                       ),
//                       Consumer<SettingsNotifier>(
//                       builder: (context,data_setting,_) {
//                         List<AdsList> customAdsList = data_setting.settingsModel
//                             .settings.admobSettings.customAds.adsList;
//                         AdsList customAds = customAdsList[0];
//                         return Column(
//                           children: <Widget>[
//
//                             Container(
//                                 child: Container(
//                                   margin: EdgeInsets.only(top: (data_custom_ads.bannerSize !=
//                                       null) ? data_custom_ads.bannerSize.height - (110 / 2) : 0),
//                                   child: Row(
//                                     children: <Widget>[
//                                       Expanded(
//                                         flex: 1,
//                                         child: Container(),
//                                       ),
//                                       Consumer<SettingsNotifier>(
//                                           builder: (context, data, _) {
//                                             List<AdsList> customAdsList = data.settingsModel
//                                                 .settings.admobSettings.customAds.adsList;
//                                             AdsList customAds = customAdsList[0];
//                                             return InkWell(
//                                             onTap: (){
//                                             _launchURL(customAds.redirectUrl);
//                                             },
//                                             child:Container(
//                                               key: _keyLogo,
//                                               width: 110,
//                                               child: Image.network(
//                                                 customAds.logoImage,
//                                                 fit: BoxFit.contain,
//                                               ),
//                                             )
//                                             );
//                                           }),
//                                       Expanded(
//                                         flex: 1,
//                                         child: Container(),
//                                       ),
//                                     ],
//                                   ),
//                                 )
//                             ),
//                             Expanded(
//                               child: Container(
//                               ),
//                             ),
//                             Container(
//                               margin: EdgeInsets.only(
//                                 bottom: (data_custom_ads.footerSize != null && data_custom_ads
//                                     .btnGoSize != null) ? data_custom_ads.footerSize.height -
//                                     (data_custom_ads.btnGoSize.height / 2) : 0,
//
//                               ),
//                               child: Row(
//                                 mainAxisAlignment: MainAxisAlignment.center,
//                                 children: <Widget>[
//                                   FloatingActionButton(
//                                       elevation: 2,
//                                       backgroundColor: Color(customAds.footerButtonColor),
//                                       key: _keyBtnGo,
//                                       onPressed: () {
//                                         _launchURL(customAds.redirectUrl);
//                                         Navigator.pop(context);
//                                       },
//                                       child: Icon(Icons.keyboard_arrow_right, size: 40,)
//                                   ),
//                                 ],
//                               ),
//                             )
//                           ],
//                         );
//                       }
//                       ),
//                       Consumer<SettingsNotifier>(
//                       builder: (context,data_setting,_) {
//                         List<AdsList> customAdsList = data_setting.settingsModel
//                             .settings.admobSettings.customAds.adsList;
//                         AdsList customAds = customAdsList[0];
//                          return Column(
//                           children: <Widget>[
//                             Row(
//                               children: <Widget>[
//                                 InkWell(
//                                   onTap: () {
//                                     Navigator.pop(context);
//                                   },
//                                   child: Container(
//                                     decoration: BoxDecoration(
//                                       color: Colors.black54,
//                                       shape: BoxShape.circle,
//                                     ),
//                                     padding: EdgeInsets.all(2),
//                                     margin: EdgeInsets.all(5),
//                                     child: Icon(
//                                       Icons.close, color: Colors.white,
//                                       size: 15,),
//                                   ),
//                                 ),
//                                 Spacer()
//                               ],
//                             ),
//                             Spacer(),
//                             Row(
//                               children: <Widget>[
//                                 InkWell(
//                                   onTap: () {
//                                     if (!data_custom_ads.isAdsInfo) {
//                                       data_custom_ads.isAdsInfo = true;
//                                     }
//                                     else {
//                                       _launchURL(customAds.privacyUrl);
//                                     }
//                                   },
//                                   child: Container(
//                                     padding: EdgeInsets.all(2),
//                                     color: Colors.black54,
//                                     alignment: Alignment.center,
//                                     child: Row(
//                                       children: <Widget>[
//                                         Icon(Icons.info_outline,
//                                           color: Colors.cyanAccent, size: 15,),
//                                         (data_custom_ads.isAdsInfo) ? Container(
//                                             padding: EdgeInsets.symmetric(
//                                                 horizontal: 5),
//                                             child: Text(customAds.privacyTitle,
//                                               style: TextStyle(
//                                                   color: Colors.cyanAccent),
//                                             )
//                                         ) : Container()
//                                       ],
//                                     ),
//                                   ),
//                                 ),
//                                 Spacer()
//                               ],
//                             )
//                           ],
//                         );
//                       }
//                       )
//                     ],
//                   ),
//                 )
//             );
//           },
//         )
//     );
//   }
// }
// */
