// To parse this JSON data, do
//
//     final admobSettings = admobSettingsFromJson(jsonString);

import 'dart:convert';

AdmobSettings admobSettingsFromJson(String str) => AdmobSettings.fromJson(json.decode(str));

String admobSettingsToJson(AdmobSettings data) => json.encode(data.toJson());

class AdmobSettings {
  AdmobSettings({
    this.isOverride,
    this.adsLoadingText,
    this.adsLoadingDelay,
    this.isBannerAds,
    this.isInterstitialAds,
    this.googleAds,
    this.unityAds,
    this.customAds,
  });

  bool? isOverride;
  String? adsLoadingText;
  int? adsLoadingDelay;
  bool? isBannerAds;
  bool? isInterstitialAds;
  GoogleAds? googleAds;
  UnityAdsPakage? unityAds;
  CustomAds? customAds;

  factory AdmobSettings.fromJson(Map<String, dynamic> json) => AdmobSettings(
    isOverride: json["is_override"],
    adsLoadingText: json["ads_loading_text"],
    adsLoadingDelay: json["ads_loading_delay"],
    isBannerAds: json["is_banner_ads"],
    isInterstitialAds: json["is_interstitial_ads"],
    googleAds: GoogleAds.fromJson(json["google_ads"]),
    unityAds: UnityAdsPakage.fromJson(json["unity_ads"]),
    customAds: CustomAds.fromJson(json["custom_ads"]),
  );

  Map<String, dynamic> toJson() => {
    "is_override": isOverride,
    "ads_loading_text": adsLoadingText,
    "ads_loading_delay": adsLoadingDelay,
    "is_banner_ads": isBannerAds,
    "is_interstitial_ads": isInterstitialAds,
    "google_ads": googleAds!.toJson(),
    "unity_ads": unityAds!.toJson(),
    "custom_ads": customAds!.toJson(),
  };
}

class CustomAds {
  CustomAds({
    this.isAds,
    this.isBannerAds,
    this.isInterstitialAds,
    this.visibilityPercentage,
    this.bannerAdsUrl,
    this.interstitialAdsUrl,
  });

  bool? isAds;
  bool? isBannerAds;
  bool? isInterstitialAds;
  int? visibilityPercentage;
  String? bannerAdsUrl;
  String? interstitialAdsUrl;

  factory CustomAds.fromJson(Map<String, dynamic> json) => CustomAds(
    isAds: json["is_ads"],
    isBannerAds: json["is_banner_ads"],
    isInterstitialAds: json["is_interstitial_ads"],
    visibilityPercentage: json["visibility_percentage"],
    bannerAdsUrl: json["banner_ads_url"],
    interstitialAdsUrl: json["interstitial_ads_url"],
  );

  Map<String, dynamic> toJson() => {
    "is_ads": isAds,
    "is_banner_ads": isBannerAds,
    "is_interstitial_ads": isInterstitialAds,
    "visibility_percentage": visibilityPercentage,
    "banner_ads_url": bannerAdsUrl,
    "interstitial_ads_url": interstitialAdsUrl,
  };
}

class GoogleAds {
  GoogleAds({
    this.adsAppIdIos,
    this.adsAppIdAndroid,
    this.bannerAdUnitIdIos,
    this.bannerAdUnitIdAndroid,
    this.interstitialAdUnitIdIos,
    this.interstitialAdUnitIdAndroid,
    this.isBannerAds,
    this.isInterstitialAds,
    this.visibilityPercentage,
  });

  String? adsAppIdIos;
  String? adsAppIdAndroid;
  String? bannerAdUnitIdIos;
  String? bannerAdUnitIdAndroid;
  String? interstitialAdUnitIdIos;
  String? interstitialAdUnitIdAndroid;
  bool? isBannerAds;
  bool? isInterstitialAds;
  int? visibilityPercentage;

  factory GoogleAds.fromJson(Map<String, dynamic> json) => GoogleAds(
    adsAppIdIos: json["ads_app_id_ios"],
    adsAppIdAndroid: json["ads_app_id_android"],
    bannerAdUnitIdIos: json["banner_ad_unit_id_ios"],
    bannerAdUnitIdAndroid: json["banner_ad_unit_id_android"],
    interstitialAdUnitIdIos: json["interstitial_ad_unit_id_ios"],
    interstitialAdUnitIdAndroid: json["interstitial_ad_unit_id_android"],
    isBannerAds: json["is_banner_ads"],
    isInterstitialAds: json["is_interstitial_ads"],
    visibilityPercentage: json["visibility_percentage"],
  );

  Map<String, dynamic> toJson() => {
    "ads_app_id_ios": adsAppIdIos,
    "ads_app_id_android": adsAppIdAndroid,
    "banner_ad_unit_id_ios": bannerAdUnitIdIos,
    "banner_ad_unit_id_android": bannerAdUnitIdAndroid,
    "interstitial_ad_unit_id_ios": interstitialAdUnitIdIos,
    "interstitial_ad_unit_id_android": interstitialAdUnitIdAndroid,
    "is_banner_ads": isBannerAds,
    "is_interstitial_ads": isInterstitialAds,
    "visibility_percentage": visibilityPercentage,
  };
}

class UnityAdsPakage {
  UnityAdsPakage({
    this.adsAppIdIos,
    this.adsAppIdAndroid,
    this.isBannerAds,
    this.isInterstitialAds,
    this.visibilityPercentage,
  });

  String? adsAppIdIos;
  String? adsAppIdAndroid;
  bool? isBannerAds;
  bool? isInterstitialAds;
  int? visibilityPercentage;

  factory UnityAdsPakage.fromJson(Map<String, dynamic> json) => UnityAdsPakage(
    adsAppIdIos: json["ads_app_id_ios"],
    adsAppIdAndroid: json["ads_app_id_android"],
    isBannerAds: json["is_banner_ads"],
    isInterstitialAds: json["is_interstitial_ads"],
    visibilityPercentage: json["visibility_percentage"],
  );

  Map<String, dynamic> toJson() => {
    "ads_app_id_ios": adsAppIdIos,
    "ads_app_id_android": adsAppIdAndroid,
    "is_banner_ads": isBannerAds,
    "is_interstitial_ads": isInterstitialAds,
    "visibility_percentage": visibilityPercentage,
  };
}
