import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:url_launcher/url_launcher.dart';
import 'package:webview_flutter_x5/webview_flutter.dart';

import 'ads/model/admob_settings.dart';

class InterstitialWebView extends StatefulWidget {
  AdmobSettings? admobSettings;

  InterstitialWebView({Key? key, required this.admobSettings})
      : super(key: key);

  void init(AdmobSettings admobSettings) {
    admobSettings = admobSettings;
  }

  @override
  _InterstitialWebViewState createState() => _InterstitialWebViewState();
}

class _InterstitialWebViewState extends State<InterstitialWebView> {
  _launchURL(String url) async {
    if (await canLaunch(url)) {
      await launch(url);
    } else {
      throw 'Could not launch $url';
    }
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
        body: Stack(
      children: [
        WebView(
          gestureNavigationEnabled: true,
          navigationDelegate: (action) {
            Get.back();

            return _launchURL(action.url);
            // return NavigationDecision.navigate;
          },
          javascriptMode: JavascriptMode.unrestricted,
          initialUrl: '${widget.admobSettings!.customAds!.interstitialAdsUrl}',
        ),
        SizedBox(
          height: 10,
        ),
        Padding(
          padding: EdgeInsets.only(left: 20, right: 20, top: 45),
          child: Align(
              alignment: Alignment.topRight,
              child: InkWell(
                  onTap: () {
                    Get.back();
                  },
                  child: Container(
                      padding: EdgeInsets.all(2),
                      decoration: BoxDecoration(
                          color: Colors.white,
                          borderRadius: BorderRadius.all(Radius.circular(300))),
                      child: Container(
                          padding: EdgeInsets.all(2),
                          decoration: BoxDecoration(
                              color: Colors.black,
                              borderRadius:
                                  BorderRadius.all(Radius.circular(300))),
                          child: Icon(
                            Icons.close,
                            color: Colors.white,
                            size: 15,
                          ))))),
        )
      ],
    ));
  }
}
